package com.sdk.esc;

import static android.app.PendingIntent.FLAG_MUTABLE;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.app.PendingIntent;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbInterface;
import android.hardware.usb.UsbManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;

import com.bumptech.glide.Glide;
import com.esc.PrinterHelper;
import com.leon.lfilepickerlibrary.LFilePicker;
import com.luck.picture.lib.basic.PictureSelector;
import com.luck.picture.lib.config.PictureConfig;
import com.luck.picture.lib.config.SelectMimeType;
import com.luck.picture.lib.entity.LocalMedia;
import com.luck.picture.lib.interfaces.OnResultCallbackListener;
import com.tbruyelle.rxpermissions2.RxPermissions;

import java.io.File;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import print.Print;
import print.PublicFunction;
import print.WifiTool;
import print.data.NetworkInformation;
import print.model.PrinterUtil;
import print.model.Table;


public class Activity_Main extends AppCompatActivity {
    private Context thisCon = null;
    private BluetoothAdapter mBluetoothAdapter;
    private PublicFunction PFun = null;
    private PublicAction PAct = null;
    private Spinner spnPrinterList = null;
    private TextView txtTips = null;
    private ArrayAdapter arrPrinterList;
    private String ConnectType = "";
    private String PrinterName = "";
    private UsbManager mUsbManager = null;
    private UsbDevice device = null;
    private static final String ACTION_USB_PERMISSION = "com.PRINTSDKSample";
    private PendingIntent mPermissionIntent = null;
    private static String[] PERMISSIONS_STORAGE = {
            "android.permission.READ_EXTERNAL_STORAGE",
            "android.permission.WRITE_EXTERNAL_STORAGE"};
    private static String[] wifi_PERMISSIONS = {
            "android.permission.CHANGE_WIFI_STATE",
            "android.permission.ACCESS_WIFI_STATE"
    };
    String baudrate = "";
    int REQUESTCODE_FROM_ACTIVITY = 1000;
    int REQUESTCODE_FROM_ACTIVITY_IMAGE = 9999;
    private ExecutorService executorService = Executors.newSingleThreadExecutor();

    private final int BITMAP_BLACKW = 0;
    private final int BITMAP_SHAKE = 1;
    private final int BITMAP_GATHER = 2;

    private final int PRINT_SUCCEED = 1;
    private final int PRINT_FAILURE = 0;

    private final int PRINT_THREE_INCH = 576;
    private final int PRINT_TWO_INCH = 384;
    private final int PRINT_FOUR_INCH = 832;

    private static final int REQUEST_ENABLE_BT = 2;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        setTitle(BuildConfig.VERSION_NAME);
        try {
            thisCon = this.getApplicationContext();
            spnPrinterList = (Spinner) findViewById(R.id.spn_printer_list);
            txtTips = (TextView) findViewById(R.id.txtTips);
            Intent intent = new Intent(ACTION_USB_PERMISSION);
            intent.setPackage(thisCon.getPackageName());
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.S) {
                mPermissionIntent = PendingIntent.getBroadcast(thisCon, 0, intent, FLAG_MUTABLE);
            }else{
                mPermissionIntent = PendingIntent.getBroadcast(thisCon, 0, intent, 0);
            }
            IntentFilter filter = new IntentFilter(ACTION_USB_PERMISSION);
            filter.addAction(UsbManager.ACTION_USB_DEVICE_DETACHED);
            filter.addAction(BluetoothDevice.ACTION_ACL_DISCONNECTED);
            filter.addAction(BluetoothAdapter.ACTION_STATE_CHANGED);
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
                thisCon.registerReceiver(mUsbReceiver, filter, RECEIVER_EXPORTED);
            }else {
                thisCon.registerReceiver(mUsbReceiver, filter);
            }
            PFun = new PublicFunction(thisCon);
            PAct = new PublicAction(thisCon);
            InitSetting();
            InitCombox();
            this.spnPrinterList.setOnItemSelectedListener(new OnItemSelectedPrinter());
            //Enable Bluetooth
            EnableBluetooth();
            handler = new Handler() {
                @Override
                public void handleMessage(Message msg) {
                    // TODO Auto-generated method stub
                    super.handleMessage(msg);
                    if (msg.what == PRINT_SUCCEED) {
                        Toast.makeText(thisCon, "succeed", Toast.LENGTH_LONG).show();
                        dialog.cancel();
                    } else {
                        Toast.makeText(thisCon, "failure", Toast.LENGTH_LONG).show();
                        dialog.cancel();
                    }
                }
            };
        } catch (Exception e) {
            Log.e("SDKSample", (new StringBuilder("Activity_Main --> onCreate ")).append(e.getMessage()).toString());
        }
    }

    private void InitSetting() {
        String SettingValue = "";
        SettingValue = PFun.ReadSharedPreferencesData("Codepage");
        if (SettingValue.equals(""))
            PFun.WriteSharedPreferencesData("Codepage", "0,PC437(USA:Standard Europe)");

        SettingValue = PFun.ReadSharedPreferencesData("Cut");
        if (SettingValue.equals(""))
            PFun.WriteSharedPreferencesData("Cut", "0");    //

        SettingValue = PFun.ReadSharedPreferencesData("Cashdrawer");
        if (SettingValue.equals(""))
            PFun.WriteSharedPreferencesData("Cashdrawer", "0");

        SettingValue = PFun.ReadSharedPreferencesData("Buzzer");
        if (SettingValue.equals(""))
            PFun.WriteSharedPreferencesData("Buzzer", "0");

        SettingValue = PFun.ReadSharedPreferencesData("Feeds");
        if (SettingValue.equals(""))
            PFun.WriteSharedPreferencesData("Feeds", "0");
    }

    //add printer list
    private void InitCombox() {
        try {
            arrPrinterList = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item);
            String strSDKType = thisCon.getString(R.string.sdk_type);
            if (strSDKType.equals("all"))
                arrPrinterList = ArrayAdapter.createFromResource(this, R.array.printer_list_all, android.R.layout.simple_spinner_item);
            if (strSDKType.equals("mkt"))
                arrPrinterList = ArrayAdapter.createFromResource(this, R.array.printer_list_mkt, android.R.layout.simple_spinner_item);
            if (strSDKType.equals("mprint"))
                arrPrinterList = ArrayAdapter.createFromResource(this, R.array.printer_list_mprint, android.R.layout.simple_spinner_item);
            if (strSDKType.equals("sycrown"))
                arrPrinterList = ArrayAdapter.createFromResource(this, R.array.printer_list_sycrown, android.R.layout.simple_spinner_item);
            if (strSDKType.equals("mgpos"))
                arrPrinterList = ArrayAdapter.createFromResource(this, R.array.printer_list_mgpos, android.R.layout.simple_spinner_item);
            if (strSDKType.equals("ds"))
                arrPrinterList = ArrayAdapter.createFromResource(this, R.array.printer_list_ds, android.R.layout.simple_spinner_item);
            if (strSDKType.equals("cst"))
                arrPrinterList = ArrayAdapter.createFromResource(this, R.array.printer_list_cst, android.R.layout.simple_spinner_item);
            if (strSDKType.equals("other"))
                arrPrinterList = ArrayAdapter.createFromResource(this, R.array.printer_list_other, android.R.layout.simple_spinner_item);
            arrPrinterList.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            PrinterName = arrPrinterList.getItem(0).toString();
            spnPrinterList.setAdapter(arrPrinterList);
        } catch (Exception e) {
            Log.e("SDKSample", (new StringBuilder("Activity_Main --> InitCombox ")).append(e.getMessage()).toString());
        }
    }

    private class OnItemSelectedPrinter implements OnItemSelectedListener {
        @Override
        public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
            PrinterName = arrPrinterList.getItem(arg2).toString();
        }

        @Override
        public void onNothingSelected(AdapterView<?> arg0) {
            // TODO Auto-generated method stub
        }
    }

    //EnableBluetooth
    @SuppressLint("MissingPermission")
    private boolean EnableBluetooth() {
        boolean bRet = false;
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        if (mBluetoothAdapter != null) {
            if (mBluetoothAdapter.isEnabled())
                return true;
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.S) {
                RxPermissions rxPermissions = new RxPermissions(this);
                rxPermissions.request(Manifest.permission.BLUETOOTH_CONNECT).subscribe(it ->{
                    if (it) {
                        if (ActivityCompat.checkSelfPermission(Activity_Main.this, Manifest.permission.BLUETOOTH_CONNECT) != PackageManager.PERMISSION_GRANTED) {
                            Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
                            startActivityForResult(enableBtIntent, REQUEST_ENABLE_BT);
                            return;
                        }
                    }
                });
            } else {
                mBluetoothAdapter.enable();
            }
            try {
                Thread.sleep(500);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            if (!mBluetoothAdapter.isEnabled()) {
                bRet = true;
                Log.d("PRTLIB", "BTO_EnableBluetooth --> Open OK");
            }
        } else {
            Log.d("SDKSample", (new StringBuilder("Activity_Main --> EnableBluetooth ").append("Bluetooth Adapter is null.")).toString());
        }
        return bRet;
    }

    //call back by scan bluetooth printer
    @Override
    protected void onActivityResult(int requestCode, int resultCode, final Intent data) {
        try {
            String strIsConnected;
            switch (resultCode) {
                case RESULT_CANCELED:
                    connectBT(data.getStringExtra("SelectedBDAddress"));
                case Print.ACTIVITY_CONNECT_WIFI:
                    strIsConnected = data.getExtras().getString("is_connected");
                    if (strIsConnected.equals("NO")) {
                        txtTips.setText(thisCon.getString(R.string.activity_main_connecterr));
                        return;
                    } else {
                        txtTips.setText(thisCon.getString(R.string.activity_main_connected));
                        return;
                    }
                case Print.ACTIVITY_PRNFILE:
                    PAct.BeforePrintAction();
                    String strPRNFile = data.getExtras().getString("FilePath");
                    System.out.println(strPRNFile);
                    Print.PrintBinaryFile(strPRNFile);
                    PAct.AfterPrintAction();
                    return;
                case RESULT_OK:
                    if (requestCode == REQUESTCODE_FROM_ACTIVITY) {
                        List<String> list = data.getStringArrayListExtra("paths");
                        String mFilename = list.get(0);
                        File file = new File(mFilename);
                        return;
                    } else if (requestCode == PictureConfig.CHOOSE_REQUEST) {
//                        setPrintDialog(data);
                        return;
                    } else if (requestCode == REQUESTCODE_FROM_ACTIVITY_IMAGE) {
                        final List<String> list = data.getStringArrayListExtra("paths");
                        if (list == null || list.size() == 0) {
                            Toast.makeText(thisCon, "请选择图片", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        AlertDialogUtil.edTextDialog(Activity_Main.this, "提示", "次数", "1", new AlertDialogUtil.setEdTextListener() {
                            @Override
                            public void onResult(String data) {
                                final int number = Integer.valueOf(data);
                                executorService.execute(new Runnable() {
                                    @Override
                                    public void run() {
                                        for (int j = 0; j < number; j++) {
                                            for (int i = 0; i < list.size(); i++) {
                                                if (list.get(i).endsWith(".bin")) {
                                                    try {
                                                        Print.PrintBinaryFile(list.get(i));
                                                    } catch (Exception e) {
                                                    }
                                                } else {
                                                    Bitmap bmp = BitmapFactory.decodeFile(list.get(i));
                                                    try {
                                                        Print.PrintBitmap(bmp, 1, 0);
                                                        bmp.recycle();
                                                    } catch (Exception e) {
                                                    }
                                                }
                                            }
                                        }

                                    }
                                });
                            }
                        });
                    }
            }
        } catch (Exception e) {
            Log.e("SDKSample", (new StringBuilder("Activity_Main --> onActivityResult ")).append(e.getMessage()).toString());
        }
        super.onActivityResult(requestCode, resultCode, data);
    }

    //连接蓝牙
    private void connectBT(final String BTmac) {
        if (TextUtils.isEmpty(BTmac))
            return;
        final ProgressDialog progressDialog = new ProgressDialog(Activity_Main.this);
        progressDialog.setMessage(getString(R.string.activity_devicelist_connect));
        progressDialog.show();
        new Thread() {
            @Override
            public void run() {
                super.run();
                try {
                    final int result = Print.PortOpen(thisCon, "Bluetooth," + BTmac);
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            if (result == 0)
                                txtTips.setText(thisCon.getString(R.string.activity_main_connected));
                            else
                                txtTips.setText(thisCon.getString(R.string.activity_main_connecterr) + result);
                        }
                    });
                    progressDialog.dismiss();
                } catch (Exception e) {
                    progressDialog.dismiss();
                }
            }
        }.start();
    }

    private void setPrintDialog(ArrayList<LocalMedia> result) {
//        List<LocalMedia> selectList = PictureSelector.obtainMultipleResult(data);
//        List<String> path = data.getStringArrayListExtra(ImageSelectorActivity.EXTRA_RESULT);
        String path = result.get(0).getPath();
        if (path.contains("content://")) {
            Uri uri = Uri.parse(path);
            path = FileUtils.getFilePathByUri_BELOWAPI11(uri, this);
            Log.d("Print", "image path: " + path);
        }
        final Bitmap bmp = BitmapFactory.decodeFile(path);
        if (bmp == null) {
            Toast.makeText(thisCon, "Image error", Toast.LENGTH_SHORT).show();
            return;
        }
        AlertDialogUtil alertDialogUtil = new AlertDialogUtil(Activity_Main.this);
        AlertDialog.Builder builder = alertDialogUtil.setAlertDialog();
        View view = alertDialogUtil.setViewID(R.layout.item_print);
        final RadioButton rbInch3 = view.findViewById(R.id.rb_inch3);
        final RadioButton rbInch2 = view.findViewById(R.id.rb_inch2);
        final RadioButton rbInch4 = view.findViewById(R.id.rb_inch4);
        final RadioButton rbLzoNo = view.findViewById(R.id.rb_lzo_no);
        final RadioButton rbZero = view.findViewById(R.id.rb_zero);
        final RadioButton rbShake = view.findViewById(R.id.rb_shake);
        final RadioButton rbBlackW = view.findViewById(R.id.rb_bw);
        final RadioButton rbBlackWThreshold = view.findViewById(R.id.rb_bw_threshold);
        final LinearLayout llThresholdArea = view.findViewById(R.id.ll_threshold_area);
        final EditText etThreshold = view.findViewById(R.id.et_threshold);
        final EditText edLight = view.findViewById(R.id.ed_light);

        llThresholdArea.setVisibility(View.GONE);
        rbBlackWThreshold.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                Log.d("zzz", "onCheckedChanged isChecked -> " + isChecked);
                llThresholdArea.setVisibility(isChecked ? View.VISIBLE : View.GONE);
            }
        });

        builder.setNegativeButton(R.string.activity_wifi_btncancel, null);
        builder.setPositiveButton(R.string.activity_global_print, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {
                String threshold = etThreshold.getText().toString();
                if (rbBlackWThreshold.isChecked() && (TextUtils.isEmpty(threshold) || threshold.length() > 4 || !Utility.isInteger(threshold) || Integer.valueOf(threshold) < 0 || Integer.valueOf(threshold) > 255)) {
                    Toast.makeText(thisCon, R.string.activity_main_threshold_message, Toast.LENGTH_SHORT).show();
                    return;
                }
                //
                String strLight = edLight.getText().toString();
                if (TextUtils.isEmpty(strLight) || strLight.length() > 4 || !Utility.isInteger(strLight) || Integer.valueOf(strLight) < -100 || Integer.valueOf(strLight) > 100) {
                    Toast.makeText(thisCon, R.string.activity_main_light_message, Toast.LENGTH_SHORT).show();
                    return;
                }
                //
                if(rbBlackWThreshold.isChecked()){
                    Print.setBinaryThreshold(Integer.valueOf(threshold));
                }else if(rbBlackW.isChecked()){
                    Print.setAutoCalcThreshold();
                }
                //
                printImage(bmp, Integer.valueOf(strLight), rbInch3.isChecked() ? PRINT_THREE_INCH : rbInch2.isChecked() ? PRINT_TWO_INCH : rbInch4.isChecked() ? PRINT_FOUR_INCH : 0, !rbZero.isChecked(), rbShake.isChecked() ? BITMAP_SHAKE : (rbBlackW.isChecked() || rbBlackWThreshold.isChecked() ? BITMAP_BLACKW : BITMAP_GATHER), !rbLzoNo.isChecked());
            }
        });
        builder.show();
    }

    public void printImage(final Bitmap bitmap, final int light, final int size, final boolean isRotate, final int sype, final boolean isLzo) {
        dialog = new ProgressDialog(Activity_Main.this);
        dialog.setMessage("Printing.....");
        dialog.setProgress(100);
        dialog.show();
        executorService.execute(new Runnable() {
            @Override
            public void run() {
                PAct.BeforePrintAction();
                Bitmap bitmapPrint = bitmap;
                if (isRotate)
                    bitmapPrint = Utility.Tobitmap90(bitmapPrint);
                if (size != 0)
                    bitmapPrint = Utility.Tobitmap(bitmapPrint, size, Utility.getHeight(size, bitmapPrint.getWidth(), bitmapPrint.getHeight()));
                int printImage = 0;
                try {
                    if (!isLzo)
                        printImage = Print.PrintBitmap(bitmapPrint, sype, light);
                    else
                        printImage = Print.PrintBitmapLZO(bitmapPrint, sype, light);
                    if (printImage >= 0) {
                        handler.sendEmptyMessage(PRINT_SUCCEED);
                    } else {
                        handler.sendEmptyMessage(PRINT_FAILURE);
                    }
//                    Print.GotoNextLabel();
                } catch (Exception e) {
                    handler.sendEmptyMessage(PRINT_FAILURE);
                }
                bitmap.recycle();
                bitmapPrint.recycle();
                PAct.AfterPrintAction();
            }
        });
    }

    private void connectionBluetooth() {
        //获取蓝牙动态权限
        RxPermissions rxPermissions = new RxPermissions(this);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.S) {
            rxPermissions.request(Manifest.permission.BLUETOOTH_ADMIN,
                    Manifest.permission.BLUETOOTH,
                    Manifest.permission.BLUETOOTH_CONNECT,
                    Manifest.permission.BLUETOOTH_SCAN,
                    Manifest.permission.ACCESS_FINE_LOCATION).subscribe(aBoolean -> {
                if (aBoolean) {
                    ConnectType = "Bluetooth";
                    Intent intent = new Intent(thisCon, BTActivity.class);
                    intent.putExtra("TAG", 0);
                    startActivityForResult(intent, 0);
                }
            });
        } else {
            rxPermissions.request(Manifest.permission.BLUETOOTH_ADMIN,
                    Manifest.permission.BLUETOOTH,
                    Manifest.permission.ACCESS_FINE_LOCATION).subscribe(aBoolean -> {
                if (aBoolean) {
                    ConnectType = "Bluetooth";
                    Intent intent = new Intent(thisCon, BTActivity.class);
                    intent.putExtra("TAG", 0);
                    startActivityForResult(intent, 0);
                }
            });
        }
    }

    private void connectionWifi() {
        //获取WIFI动态权限
        RxPermissions rxPermissions = new RxPermissions(this);
        rxPermissions.request(Manifest.permission.ACCESS_COARSE_LOCATION, Manifest.permission.ACCESS_FINE_LOCATION).subscribe(aBoolean -> {
            if (aBoolean) {
                setWifiDialog();
            }
        });
    }

    @SuppressLint("NewApi")
    public void onClickConnect(View view) {
        if (!checkClick.isClickEvent()) return;

        try {
            if (view.getId() == R.id.btnBT) {
                connectionBluetooth();
                return;
            } else if (view.getId() == R.id.btnWIFI) {
                connectionWifi();
                return;
            } else if (view.getId() == R.id.btnUSB) {
                connectUSB();
            } else if (view.getId() == R.id.btnSerial) {
                ConantSerial(Activity_Main.this);
            }
        } catch (Exception e) {
            Log.e("SDKSample", (new StringBuilder("Activity_Main --> onClickConnect " + ConnectType)).append(e.getMessage()).toString());
        }
    }

    private void connectUSB() {
        ConnectType = "USB";
        //USB not need call "iniPort"
        mUsbManager = (UsbManager) thisCon.getSystemService(Context.USB_SERVICE);
        HashMap<String, UsbDevice> deviceList = mUsbManager.getDeviceList();
        Iterator<UsbDevice> deviceIterator = deviceList.values().iterator();

        boolean HavePrinter = false;
        while (deviceIterator.hasNext()) {
            device = deviceIterator.next();
            int count = device.getInterfaceCount();
            for (int i = 0; i < count; i++) {
                UsbInterface intf = device.getInterface(i);
                if (intf.getInterfaceClass() == 7) {
                    HavePrinter = true;
                    if (mPermissionIntent != null){
                        Log.d("PRINT_TAG", "vendorID--" + device.getVendorId() + "ProductId--" + device.getProductId());
                        mUsbManager.requestPermission(device, mPermissionIntent);
                    }
                }
            }
        }
        if (!HavePrinter)
            txtTips.setText(thisCon.getString(R.string.activity_main_connect_usb_printer));
    }

    private BroadcastReceiver mUsbReceiver = new BroadcastReceiver() {
        public void onReceive(Context context, Intent intent) {
            try {
                String action = intent.getAction();
                Log.d("TAG", "action: "+action);
                if (ACTION_USB_PERMISSION.equals(action)) {
                    synchronized (this) {
                        device = (UsbDevice) intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);
                        if (intent.getBooleanExtra(UsbManager.EXTRA_PERMISSION_GRANTED, false)) {
                            if (Print.PortOpen(thisCon, device) != 0) {
                                txtTips.setText(thisCon.getString(R.string.activity_main_connecterr));
                                return;
                            } else
                                txtTips.setText(thisCon.getString(R.string.activity_main_connected));

                        } else {
                            return;
                        }
                    }
                }
                if (UsbManager.ACTION_USB_DEVICE_DETACHED.equals(action)) {
                    device = (UsbDevice) intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);
                    if (device != null) {
                        int count = device.getInterfaceCount();
                        for (int i = 0; i < count; i++) {
                            UsbInterface intf = device.getInterface(i);
                            //Class ID 7代表打印机
                            if (intf.getInterfaceClass() == 7) {
                                Print.PortClose();
                                txtTips.setText(R.string.activity_main_tips);
                            }
                        }
                    }
                }
                if (BluetoothDevice.ACTION_ACL_DISCONNECTED.equals(action)) {
                    if (Print.IsOpened()) {
                        Log.d("Print", "BluetoothBroadcastReceiver:Bluetooth close");
//                    Print.disConnection();
//                    sendBroadcast(new Intent(ACTION_PRINT_DISCONNECTED));
                        try {
                            Print.PortClose();
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                        txtTips.setText(R.string.activity_main_tips);
                        Utility.show(thisCon, getString(R.string.activity_main_close));
                    }
                } else if (BluetoothAdapter.ACTION_STATE_CHANGED.equals(action)) {
                    int state = intent.getIntExtra(BluetoothAdapter.EXTRA_STATE,
                            BluetoothAdapter.ERROR);
                    switch (state) {
                        case BluetoothAdapter.STATE_OFF:
                            Log.d("Print", "STATE_OFF 手机蓝牙关闭");
                            if (Print.IsOpened()) {
                                Log.d("Print", "BluetoothBroadcastReceiver:Bluetooth close");
                                try {
                                    Print.PortClose();
                                } catch (Exception e) {
                                    e.printStackTrace();
                                }
                                txtTips.setText(R.string.activity_main_tips);
                                Utility.show(thisCon, getString(R.string.activity_main_close));
                            }
                            break;
                        case BluetoothAdapter.STATE_TURNING_OFF:
                            Log.d("Print", "STATE_TURNING_OFF 手机蓝牙正在关闭");
                            break;
                        case BluetoothAdapter.STATE_ON:
                            Log.d("Print", "STATE_ON 手机蓝牙开启");
                            break;
                        case BluetoothAdapter.STATE_TURNING_ON:
                            Log.d("Print", "STATE_TURNING_ON 手机蓝牙正在开启");
                            break;
                    }
                }
            } catch (Exception e) {
                Log.e("SDKSample", (new StringBuilder("Activity_Main --> mUsbReceiver ")).append(e.getMessage()).toString());
            }
        }
    };
    private Handler handler;
    private ProgressDialog dialog;

    public void onClickClose(View view) {
        if (!checkClick.isClickEvent()) return;

        try {

            Print.PortClose();

            this.txtTips.setText(R.string.activity_main_tips);
            return;
        } catch (Exception e) {
            Log.e("SDKSample", (new StringBuilder("Activity_Main --> onClickClose ")).append(e.getMessage()).toString());
        }
    }

    public void onClickbtnSetting(View view) {
        if (!checkClick.isClickEvent()) return;

        try {
            startActivity(new Intent(Activity_Main.this, Activity_Setting.class));
        } catch (Exception e) {
            Log.e("SDKSample", (new StringBuilder("Activity_Main --> onClickClose ")).append(e.getMessage()).toString());
        }
    }

    public void onClickDo(View view) throws Exception {
        if (!checkClick.isClickEvent()) return;
        if (!Print.IsOpened()) {
            Toast.makeText(thisCon, thisCon.getText(R.string.activity_main_tips), Toast.LENGTH_SHORT).show();
            return;
        }
        if (view.getId() == R.id.btnGetStatus) {
            getPrintStatus();
        } else if (view.getId() == R.id.btnOpenCashDrawer) {
            Intent myIntent = new Intent(this, Activity_Cashdrawer.class);
            startActivityFromChild(this, myIntent, 0);
        } else if (view.getId() == R.id.btnSampleReceipt) {
            PrintSampleReceipt();
        } else if (view.getId() == R.id.btn1DBarcodes) {
            Intent myIntent = new Intent(this, Activity_1DBarcodes.class);
            startActivityFromChild(this, myIntent, 0);
        } else if (view.getId() == R.id.btnCut) {
            Intent myIntent = new Intent(this, Activity_Cut.class);
            startActivityFromChild(this, myIntent, 0);
        } else if (view.getId() == R.id.btnTextFormat) {
            Intent myIntent = new Intent(this, Activity_TextFormat.class);
            startActivityFromChild(this, myIntent, 0);
        } else if (view.getId() == R.id.btnPrintImageFile) {
            String[] permissions;
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU){
                permissions = new String[]{Manifest.permission.READ_MEDIA_IMAGES, Manifest.permission.READ_MEDIA_AUDIO, Manifest.permission.READ_MEDIA_VIDEO};
            }else{
                permissions = new String[]{Manifest.permission.READ_EXTERNAL_STORAGE};
            }
            RxPermissions rxPermissions = new RxPermissions(this);
            rxPermissions.request(permissions).subscribe(aBoolean -> {
                if (aBoolean){
                    setImageDialog();
                }
            });
        } else if (view.getId() == R.id.btnPrintCardRead) {
            Activity_Magnetic_Card.startActivity(this);
        } else if (view.getId() == R.id.btnPageMode) {
            RxPermissions rxPermissions = new RxPermissions(this);
            rxPermissions.request(Manifest.permission.WRITE_EXTERNAL_STORAGE, Manifest.permission.READ_EXTERNAL_STORAGE).subscribe(aBoolean -> {
                if (aBoolean){
                    printPDF();
                }
            });
        } else if (view.getId() == R.id.btnQRCode) {
            Intent myIntent = new Intent(this, Activity_QRCode.class);
            startActivityFromChild(this, myIntent, 0);
        } else if (view.getId() == R.id.btnPDF417) {
            Intent myIntent = new Intent(this, Activity_PDF417.class);
            startActivityFromChild(this, myIntent, 0);
        } else if (view.getId() == R.id.btnSN) {
            getPrinterSN();
        } else if (view.getId() == R.id.btnPrintTestPage) {
            PrintTestPage();
        } else if (view.getId() == R.id.btnprintself) {
            printSelf();
        } else if (view.getId() == R.id.btnboxstatus) {
            getCashDrawer();
        } else if (view.getId() == R.id.btnsiyuan) {
            printSiYuan();
        } else if (view.getId() == R.id.btn_quantity) {
            getPrinterQuantity();
        } else if (view.getId() == R.id.btn_density) {
            setDensity();
        } else if (view.getId() == R.id.btn_network) {
            getNetworkInformation();
        } else if (view.getId() == R.id.btn_set_network) {
            setNetworkParameter();
        } else if (view.getId() == R.id.btn_print_table) {
            printTable();
        } else if (view.getId() == R.id.btn_print_util) {
            printUtil();
        }
    }

    private void printUtil() {
        try {
            InputStream inputStream = getResources().getAssets().open("111.jpg");
            Bitmap bitmap = BitmapFactory.decodeStream(inputStream);
            PrinterUtil printerUtil = new PrinterUtil();
            printerUtil.addText("test",0,false,false, false, 0, 0);
            printerUtil.addText("test",1,true,true, true, 0, 0);
            printerUtil.addText("test",2,false,false, false, 1, 1);
            printerUtil.addImage(2,1,200,200, bitmap);
            printerUtil.addImage(1,1,200,200, bitmap);
            printerUtil.addImage(0,1,100,100, bitmap);
            String column = "品名;数量;单价;金额";
            Table table = new Table(column, ";", new int[]{4, 6, 6, 6});
            table.setColumnAlign(1);
            table.addRow("保鲜袋" + ";10.00;1;10.00");
            table.addRow("铁丝挂钩" + ";5.00;2;10.00");
            table.addRow("雨伞" + ";5.00;3;15.00");
            printerUtil.addTable(table);
            printerUtil.print();
        } catch (Exception e) {
        }
    }

    private void setNetworkParameter() {
        AlertDialog.Builder builder = new AlertDialog.Builder(Activity_Main.this);
        View inflate = LayoutInflater.from(Activity_Main.this).inflate(R.layout.item_network, null);
        builder.setView(inflate);
        RadioButton rbDhcpYes = inflate.findViewById(R.id.rb_dhcp_yes);
        EditText edIP = inflate.findViewById(R.id.ed_ip);
        EditText edSubnetMask = inflate.findViewById(R.id.ed_subnet_mask);
        EditText edGateway = inflate.findViewById(R.id.ed_gateway);
        builder.setPositiveButton(R.string.main_setting, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                Print.setDHCP(rbDhcpYes.isChecked() ? 1 : 0);
                Print.setPrintIP(edIP.getText().toString());
                Print.setPrintSubnetMask(edSubnetMask.getText().toString());
                Print.setPrintGateway(edGateway.getText().toString());
                switch (Print.setPrintSave()) {
                    case Print.SUCCEED:
                        Utility.show(Activity_Main.this, getString(R.string.setting_success));
                        break;
                    case Print.ERROR_SAVE_FAIL:
                        Utility.show(Activity_Main.this, getString(R.string.setting_fail));
                        break;
                    case Print.ERROR_NO_CONNECT:
                        Utility.show(Activity_Main.this, getString(R.string.send_fail));
                        break;
                }
            }
        });
        builder.setNegativeButton(R.string.activity_wifi_btncancel, null);
        builder.show();
    }

    private void getNetworkInformation() {
        executorService.submit(new Runnable() {
            @Override
            public void run() {
                int dhcp = Print.isDHCP();
                String printIP = Print.getPrintIP();
                String printSubnetMask = Print.getPrintSubnetMask();
                String printGateway = Print.getPrintGateway();
                NetworkInformation networkInformation = new NetworkInformation();
                networkInformation.setDhcp(dhcp == 1);
                networkInformation.setIp(printIP);
                networkInformation.setSubnetMask(printSubnetMask);
                networkInformation.setGateway(printGateway);
                if (networkInformation == null) {
                    Utility.show(Activity_Main.this, getString(R.string.activity_devicelist_get_device_err));
                } else {
                    Utility.show(Activity_Main.this, networkInformation.toString());
                }
            }
        });
    }

    private void setDensity() {
        AlertDialog.Builder builder = new AlertDialog.Builder(Activity_Main.this);
        String[] str = new String[]{"1", "2", "3", "4"};
        builder.setTitle(getString(R.string.activity_main_density));
        builder.setItems(str, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                try {
                    PrinterHelper.WriteData(new byte[]{0x12, 0x01, (byte) (which + 1)});
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
        builder.show();
    }

    private void getPrinterQuantity() {
        int printerQuantity = Print.getPrinterQuantity();
        if (printerQuantity == -1) {
            Toast.makeText(thisCon, getString(R.string.activity_devicelist_get_device_err), Toast.LENGTH_SHORT).show();
            return;
        }
        if (printerQuantity == -2) {
            Toast.makeText(thisCon, getString(R.string.acticity_main_nonsupport), Toast.LENGTH_SHORT).show();
            return;
        }
        Toast.makeText(thisCon, "" + printerQuantity, Toast.LENGTH_SHORT).show();
    }

    private void printSiYuan() {
        try {
            Print.printSiYuanText(32, "测试思源32字体");
            Print.printSiYuanText(36, "测试思源36字体");
            Print.printSiYuanText(42, "测试思源42字体");
        } catch (Exception e) {
        }
    }

    private void getCashDrawer() {
        Log.d("Print", "getCashDrawer: start");
        try {
            while (Print.ReadData(200).length > 0) {
            }
            Print.WriteData(new byte[]{0x1D, 0x72, 0x02});
            byte[] status = Print.ReadData(2000);
            if (status == null || status.length != 1) {
                Utility.show(thisCon, "time out");
                return;
            }
            Log.d("Print", "getCashDrawer: status " + status[0]);
            if (status[0] == 1) {
                Utility.show(this, "Cash Drawer Close");
            } else if (status[0] == 0) {
                Utility.show(this, "Cash Drawer Open");
            } else {
                Utility.show(this, "Data Error");
            }
        } catch (Exception e) {
        }
    }

    private void getPrintStatus() {
        try {
            String statusStr = "";
            byte[] bytes = Print.GetRealTimeStatus((byte) 2);
            if ((bytes[0] & 4) == 4) {
                //开盖
                statusStr = getString(R.string.activity_status_real_time_status_cover_is_open);
            } else {
                //合盖
                statusStr = getString(R.string.activity_status_real_time_status_cover_is_close);
            }
            byte[] bytes1 = Print.GetRealTimeStatus((byte) 4);
            if ((bytes1[0] & 96) == 96) {
                //无纸
                statusStr = statusStr + " " + getString(R.string.activity_status_transmit_status_no_paper);
            } else {
                //有纸
                statusStr = statusStr + " " + getString(R.string.activity_status_transmit_status_has_paper);
            }
            if ((bytes1[0] & 12) == 12) {
                //纸将尽
                statusStr = statusStr + " " + getString(R.string.activity_status_real_time_status_paper_near_end);
            } else {
                //纸充足
                statusStr = statusStr + " " + getString(R.string.activity_status_real_time_status_paper_adquate);
            }
            if (TextUtils.isEmpty(statusStr))
                return;
            Toast.makeText(thisCon, statusStr, Toast.LENGTH_SHORT).show();
        } catch (Exception e) {
        }
    }

    private void printSelf() {
        try {
            Print.printSelf();
        } catch (Exception e) {
        }
    }

    private void getPrinterSN() {
        try {
            String printSN = Print.getPrintSN();
            if (TextUtils.isEmpty(printSN)) {
                Toast.makeText(thisCon, thisCon.getText(R.string.activity_devicelist_get_device_err), Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(thisCon, printSN, Toast.LENGTH_SHORT).show();
            }
        } catch (Exception e) {
        }
    }


    private void printTest() {
        try {
            InputStream inputStream = getResources().getAssets().open("111.jpg");
            Bitmap bitmap = BitmapFactory.decodeStream(inputStream);
            PrinterUtil printerUtil = new PrinterUtil();
            printerUtil.addText("test",0,false,false, false, 0, 0);
            printerUtil.addText("test",1,true,true, true, 0, 0);
            printerUtil.addText("test",2,false,false, false, 1, 1);
            printerUtil.addImage(1,1,200,200, bitmap);
            printerUtil.print();
        } catch (Exception e) {
        }
    }


    private void printPDF() {
        new LFilePicker()
                .withActivity(this)
                .withRequestCode(REQUESTCODE_FROM_ACTIVITY)
                .withStartPath(Environment.getExternalStorageDirectory().getAbsolutePath())
                .withTitle(getResources().getString(R.string.activity_esc_function_btnpagemode))
                .withMutilyMode(false)
                .withBackgroundColor("#000000")
                .withTitleColor("#ffffff")
                .withFileFilter(new String[]{".PDF", ".pdf"})
                .start();
    }

    private void setImageDialog() {
        PictureSelector.create(this)
                .openGallery(SelectMimeType.ofImage())
                .setImageEngine(GlideEngine.createGlideEngine())
                .forResult(new OnResultCallbackListener<LocalMedia>() {
                    @Override
                    public void onResult(ArrayList<LocalMedia> result) {
                        setPrintDialog(result);
                    }

                    @Override
                    public void onCancel() {

                    }
                });

    }

    public class GlideLoader implements com.yancy.imageselector.ImageLoader {

        @Override
        public void displayImage(Context context, String path, ImageView imageView) {
            Glide.with(context)
                    .load(path)
//                    .placeholder(com.yancy.imageselector.R.mipmap.imageselector_photo)
                    .centerCrop()
                    .into(imageView);
        }
    }

    public void PrintTestPage() {
        try {
            PAct.BeforePrintAction();
            String strPrintText = "Print SDK Sample!";
            Print.PrintText(thisCon.getString(R.string.activity_main_originalsize) + strPrintText + "\n", 0, 0, 0);
            Print.PrintText(thisCon.getString(R.string.activity_main_bold) + strPrintText + "\n", 0, 2, 0);
            Print.PrintText(thisCon.getString(R.string.activity_main_underline) + strPrintText + "\n", 0, 4, 0);
            Print.PrintText(thisCon.getString(R.string.activity_main_minifront) + strPrintText + "\n", 0, 1, 0);
            Barcode_BC_UPCA();
            Barcode_BC_UPCE();
            Barcode_BC_EAN8();
            Barcode_BC_EAN13();
            Barcode_BC_CODEBAR();
            Barcode_BC_ITF();
            Barcode_BC_CODE128();
            PAct.AfterPrintAction();
        } catch (Exception e) {
            Log.e("SDKSample", (new StringBuilder("Activity_Main --> onClickWIFI ")).append(e.getMessage()).toString());
        }
    }

    private int Barcode_BC_UPCA() throws Exception {
        Print.PrintText("BC_UPCA:\n");
        return Print.PrintBarCode(Print.BC_UPCA,
                "075678164125");
    }

    private int Barcode_BC_UPCE() throws Exception {
        Print.PrintText("BC_UPCE:\n");
        return Print.PrintBarCode(Print.BC_UPCE,
                "01227000009");//04252614
    }

    private int Barcode_BC_EAN8() throws Exception {
        Print.PrintText("BC_EAN8:\n");
        return Print.PrintBarCode(Print.BC_EAN8,
                "04210009");
    }

    private int Barcode_BC_EAN13() throws Exception {
        Print.PrintText("BC_EAN13:\n");
        return Print.PrintBarCode(Print.BC_EAN13,
                "6901028075831");
    }

    private int Barcode_BC_CODE93() throws Exception {
        Print.PrintText("BC_CODE93:\n");
        return Print.PrintBarCode(Print.BC_CODE93,
                "TEST93");
    }

    private int Barcode_BC_CODE39() throws Exception {
        Print.PrintText("BC_CODE39:\n");
        return Print.PrintBarCode(Print.BC_CODE39,
                "123456789");
    }

    private int Barcode_BC_CODEBAR() throws Exception {
        Print.PrintText("BC_CODEBAR:\n");
        return Print.PrintBarCode(Print.BC_CODEBAR,
                "A40156B");
    }

    private int Barcode_BC_ITF() throws Exception {
        Print.PrintText("BC_ITF:\n");
        return Print.PrintBarCode(Print.BC_ITF,
                "123456789012");
    }

    private int Barcode_BC_CODE128() throws Exception {
        Print.PrintText("BC_CODE128:\n");
        return Print.PrintBarCode(Print.BC_CODE128,
                "{BS/N:{C\014\042\070\116{A3");    // decimal 1234 = octonary 1442
    }


    private void PrintSampleReceipt() {
        executorService.execute(new Runnable() {
            @Override
            public void run() {
                try {
                    Print.Initialize();
                    PAct.BeforePrintAction();
                    String[] ReceiptLines = getResources().getStringArray(R.array.activity_main_sample_2inch_receipt);
                    String str = "";
                    for (int i = 0; i < ReceiptLines.length; i++) {
                        str += ReceiptLines[i];
                    }
//                    Print.WriteData(new byte[]{0x0a});
                    int result = Print.PrintText(str);
                    Print.PrintAndFeedNLine((byte)5);
                    PAct.AfterPrintAction();
                } catch (Exception e) {
                    Log.e("Print", (new StringBuilder("Activity_Main --> PrintSampleReceipt ")).append(e.getMessage()).toString());
                }
            }
        });
    }

    private void ConantSerial(Context context) {
        AlertDialog.Builder builder = new AlertDialog.Builder(context);
        View inflate = LayoutInflater.from(context).inflate(R.layout.item_serial_dialog, null);
        final Spinner sp_serial_baudrate = (Spinner) inflate.findViewById(R.id.sp_serial_baudrate);
        final String[] sList = new String[]{"9600", "14400", "19200", "115200", "921600"};
        arrPrinterList = new ArrayAdapter<String>(Activity_Main.this, android.R.layout.simple_spinner_item, sList);
        sp_serial_baudrate.setAdapter(arrPrinterList);
        sp_serial_baudrate.setOnItemSelectedListener(new OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                baudrate = sList[position];
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        final EditText ed_serial_port = (EditText) inflate.findViewById(R.id.ed_serial_port);
        builder.setPositiveButton(getResources().getString(R.string.activity_wifi_btnconnect), new AlertDialog.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {
                // TODO Auto-generated method stub
                String port = ed_serial_port.getText().toString();
                if ("".equals(baudrate)) {
                    Toast.makeText(getApplicationContext(), getString(R.string.serial_dialog_nobaudrate), Toast.LENGTH_LONG).show();
                    return;
                }
                if ("".equals(port)) {
                    Toast.makeText(getApplicationContext(), getString(R.string.serial_dialog_noport), Toast.LENGTH_LONG).show();
                    return;
                }
                try {
                    int portOpen = Print.PortOpen(thisCon, "Serial," + port + "," + baudrate);
                    if (portOpen == -1) {
                        txtTips.setText(thisCon.getString(R.string.activity_main_connecterr));
                    } else {
                        txtTips.setText(thisCon.getString(R.string.activity_main_connected));
                    }
                } catch (Exception e) {
                    txtTips.setText(thisCon.getString(R.string.activity_main_connecterr));
                }
            }
        });
        builder.setNegativeButton(getString(R.string.activity_wifi_btncancel), null);
        builder.setView(inflate);
        builder.show();
    }

    private void setWifiDialog() {
        AlertDialog.Builder builder = new AlertDialog.Builder(Activity_Main.this);
        String[] str = new String[]{getString(R.string.wifi_select_ip_connection), getString(R.string.wifi_select_udp_connection)};
        builder.setItems(str, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                switch (which) {
                    case 0:
                        ConnectType = "WiFi";
                        Intent serverIntent = new Intent(thisCon, Activity_Wifi.class);
                        serverIntent.putExtra("PN", PrinterName);
                        startActivityForResult(serverIntent, Print.ACTIVITY_CONNECT_WIFI);
                        break;
                    case 1:
                        connectionUDP();
                        break;
                    default:
                        break;
                }
            }
        });
        builder.show();
    }

    private void connectionUDP() {
        if (!WifiTool.isWifi(thisCon)) {
            Toast.makeText(thisCon, "please connection wifi", Toast.LENGTH_SHORT).show();
            return;
        }
        startActivityForResult(new Intent(Activity_Main.this, Activity_UDP.class), 100);
    }

    private void printTable() {
        try {
            Print.Initialize();//初始化
            String column = "品名;数量;单价;金额";
            Table table = new Table(column, ";", new int[]{6, 6, 6, 6});
            table.setColumnAlign(2);
            table.addRow("保鲜袋" + ";10.00;1;10.00");
            table.addRow("铁丝挂钩" + ";5.00;2;10.00");
            table.addRow("雨伞" + ";5.00;3;15.00");
            Print.printTable(table);
        } catch (Exception e) {
            Log.e("Print", (new StringBuilder("Activity_Main --> printTable ")).append(e.getMessage()).toString());
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        try {
            Print.PortClose();
        } catch (Exception e) {
        }
    }

    public void test() {
        try {
            InputStream input = getResources().getAssets().open("ic.jpg");
            SimpleImageInfo simpleImageInfo = new SimpleImageInfo(input);
            Log.d("Print", "simpleImageInfo: " + simpleImageInfo.toString());
        } catch (Exception e) {
        }
    }

    public void test(View view) {
        printTest();
    }
}
